Add new issue status to all workflows by default
2011-09-11 19:08 - Jan from Planio www.plan.io

Status: New Start date: 2011-09-11
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues workflow Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution:

Description

At *Planio Online Project Management* which is based on Redmine, we keep getting user feedback about the following situation:

A new user tries to add an issue status. He/She successfully finds the "Issue Statuses" section within "Administration" and adds a
new status but gets confused that the status cannot be assigned when creating or updating an issue. Many users give up at this
point and we need to help them explaining how to find and use the "Workflow" section. The "Only display statuses that are used by
this tracker" checkbox (which is checked by default) represents another common pitfall as a newly created status won't be
available in the matrix unless the checkbox is unchecked.

In an attempt to improve the situation, we created this patch. It adds a checkbox to the "New status" view allowing the user to add
the to-be-created status to all workflows by default. The checkbox is checked by default, but it can be unchecked by advanced
users who only want to use the new status in certain workflows. We have found that in many cases, teams aren't making use of
Redmine’'s great role-based workflow permission system. Instead, many allow everyone on a project to use every issue status.
This patch helps those users all while allowing advanced admins to configure the fine-grained permissions on workflows.

Looking forward to your feedback and would love to see this getting into the core. We believe it will help first-time Redmine users
adopt and learn Redmine.

Related issues:

Related to Redmine - Feature #30916: Show warning when no tracker uses the st... Closed
Is duplicate of Redmine - Feature #9121: New statuses not available for use New 2011-08-25
History

#1 - 2011-09-11 19:10 - Jan from Planio www.plan.io

N.B. The feature becomes a performance problem once there are many issue statuses/roles/trackers. Improvements (using raw SQL?) are welcome.
We went for the ActiveRecord based approach, because it's easier to maintain and less likely to break with future Redmine changes.

#2 - 2011-09-12 09:07 - Etienne Massip

Duplicates #9121 which description is not as complete so | keep this one open.
#3 - 2011-09-21 03:19 - Yehuda Katz
Duplicate comment from #9121

The patch works for me.
My only comment is that it appears that the built-in workflows leave the diagonal line of status->itself unchecked. Not sure if that really matters.

#4 - 2011-09-21 10:38 - Jan from Planio www.plan.io

| don't think it does from a functionality point of view, but it seems to be the right thing to be in line with the default workflows. Plus, it will improve the
performance a bit.

Just removing line 24

Workflow.create! :tracker_id => tracker.id, :0ld_status => @issue_status, :new_status => @issue_status, :role
=> role # self-to-self

from the patch will accomplish that. I'll leave that to the person committing this.

#5 - 2012-10-12 21:53 - Yehuda Katz
- File changeset_a34bffe750ce27d8cda5fa83e60f5f5525054fd.diff added
Updated patch for Redmine current trunk.

#6 - 2012-10-12 23:38 - Yehuda Katz

That patch does not seem to be working. | will test more, but don't use it.

#7 - 2013-01-12 18:22 - Daniel Felix

Yehuda Katz wrote:

That patch does not seem to be working. | will test more, but don't use it.

Any news on this?

#8 - 2018-02-27 01:58 - Go MAEDA

- Target version set to Candidate for next major release

#9 - 2019-02-25 23:46 - Go MAEDA

- Related to Feature #30916: Show warning when no tracker uses the status in the workflows added

Files
changeset_r9e80ae182e30c58857¢c8e30260f7fc3788dd7597.diff 30.7 KB 2011-09-11 Jan from Planio www.plan.io
changeset_a34bffe750ce27d8cda5fa83e60f5ff5525054fd.diff 25.4 KB 2012-10-12 Yehuda Katz
